﻿//--------------------------------------------------------------------------------------
// Copyright (c) Microsoft Corp. 
//
// File: BubbleTube.xaml.cs
//
// Licensed under the Apache License, Version 2.0 (the "License"); you may not use this 
// file except in compliance with the License. You may obtain a copy of the License at 
// http://www.apache.org/licenses/LICENSE-2.0  
//  
// THIS CODE IS PROVIDED *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
// EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED WARRANTIES OR 
// CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABLITY OR NON-INFRINGEMENT. 
//  
// See the Apache Version 2.0 License for specific language governing permissions and 
// limitations under the License.
//--------------------------------------------------------------------------------------


using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Media.Animation;
using Windows.UI.Xaml.Navigation;

// The User Control item template is documented at http://go.microsoft.com/fwlink/?LinkId=234236

namespace BubblePopper
{
    public sealed partial class BubbleTube : UserControl
    {
        public const int TubeWidth = 40;
        public const int TubeHeight = 50;

        public BubbleTube()
        {
            this.InitializeComponent();
        }

        public BubbleTube(TransformGroup transform, Point point)
        {
            this.InitializeComponent();

            this.RenderTransform = transform;
            this.RenderTransformOrigin = point;
            this.Point = point;
            rect.Height = TubeHeight;
            rect.Width = TubeWidth;
        }

        public Point Point { get; set; }
    }
}
